<!--suppress CheckEmptyScriptTag -->
<style scoped>
    .world-wrapper {
        background-color: #d8efff;
    }
</style>

<template>
    <div class="world-wrapper">
        <world-wrapper svgName="World Map" :width="width" :iconColor="color">
            <circle v-for="node in nodes" :cx="node.cx" :cy="node.cy" :r="radius"
                    :stroke="strokeColor" :stroke-width="strokeWidth" />
            <slot />
        </world-wrapper>
    </div>
</template>

<script>
    import worldNodes from './worldNodes';

    // noinspection JSUnusedGlobalSymbols
    export default {
        name: "World",

        props: {
            width: { // The width to assign to the world map
                type: Number,
                default: 600,
                validator: function (value) {
                    return Math.floor(value) === value;
                }
            },
            radius: { // The radius to assign to each point that draws the world
                type: Number,
                default: 0.3,
                validator: function (value) {
                    return value >= 0.1 && value <=0.9;
                }
            },
            color: { // Color to assign to each point that draws the world
                type: String,
                default: '#333'
            },
            strokeColor: { // Color to assign to each border of each point that draws the world
                type: String,
                default: '#222'
            }
        },

        computed: {
            /**
             * Determine an aesthetically pleasing border width for each point that draws
             * the world
             */
            strokeWidth: function () {
                let stroke = this.radius / 10;

                if (stroke < 0.1) {
                    stroke = 0.1;
                }
                if (stroke > 1) {
                    stroke = 1;
                }

                return stroke;
            }
        },

        data: function() {
            return {
                // All nodes that draw the world (procured from ./worldNodes.js)
                nodes: worldNodes
            }
        },
    }
</script>